UNIT BOXPARS;

INTERFACE



FUNCTION CMD_PARSE(C:BYTE;
                 S,
                 OPT_ALLOWED,
                 OPT_DEFAULT:STRING;
                 TYP:BYTE):BOOLEAN;


FUNCTION NEXTMSG(C:BYTE):WORD;

IMPLEMENTATION

USES BOXVARS,IADVAR,VIDEO;

FUNCTION CMD_PARSE;

VAR STATE:BYTE;
    RUBRIK,OPT,SUCH,BID:STRING;
    LAST_OPT:CHAR;
    TMP:STRING[6];
    start,stop:WORD;
    long:LONGINT;
    err:INTEGER;
LABEL weiter,vonvorne;

PROCEDURE Fehler(meldung:STRING);
BEGIN
  Putdata(c,' '+s+#13);
  PutData(c,stringd(' ',B+2)+'^');
  PutData(c,meldung);
  STATE:=255;
END;

BEGIN
  CMD_PARSE:=FALSE;
  IF KS[c]^.BoxData=NIL THEN
    EXIT
  RUBRIK:='';
  OPT:=OPT_DEFAULT;
  SUCH:='';
  BID:='';
  FOR B:=1 TO LENGTH(S) DO
  BEGIN
   vonvorne:
    IF STATE=0 THEN
    (* neues feld (startsymbol) *)
    BEGIN
      IF S[B]=' ' THEN
        GOTO weiter;
      IF S[B]='-' THEN
      BEGIN
        STATE:=1;
        GOTO Weiter;
      END;
      ELSE
      IF (S[B]='"') THEN
      BEGIN
        STATE:=2;
        GOTO Weiter;
      END
      ELSE
      IF S[B]='$' THEN
      BEGIN
        STATE:=3;
        Goto Weiter;
      END
      ELSE
      IF ((Upcase(S[B])<='Z') AND (Upcase(S[B])>='A')) OR
         ((S[B]<='9') AND (S[B]>='0')) THEN
        STATE:=4
      ELSE
      BEGIN
        Fehler('Parse error!');
        Goto Weiter;
      END;
    END;
    IF STATE=1 THEN
    (* eine option wurde mit - eingeleitet *)
    BEGIN
      IF S[B]='-' THEN
      (* die vorhergehende option wird gelscht *)
      BEGIN
        IF (B>1) AND (S[B-1]<>'-') THEN
        (* es gibt eine vorhergehende option *)
        BEGIN
          IF POS(Upcase(S[b-1]),OPT)>0 THEN
            DELETE(OPT,POS(Upcase(S[B-1]),OPT),1)
        END ELSE
        BEGIN
          IF B>1 THEN
          (* aha, wir wollen eine rubrik angeben, die mit "-" beginnt *)
          BEGIN
            RUBRIK:='-'
            STATE::=4;
          END ELSE
            Fehler('Invalid option: -');
        END
      END ELSE
      IF POS(Upcase(S[B]),OPT_ALLOWED)>0 THEN
      (* gibt es diese option berhaupt ? *)
      BEGIN
        IF POS(Upcase(S[B]),OPT)=0 THEN
          OPT:=OPT+S[b];
        END ELSE
          Fehler('Invalid Option: '+S[b]);
      END ELSE
      IF S[B]=' ' THEN
      (* wenn ein space kommt, hat sich ausgeoptiont *)
        STATE:=0;
      GOTO Weiter;
    END;
    IF STATE=3 THEN
    (* BID *)
    BEGIN
      IF (Upcase(S[B]) IN ['A'..'Z','0'..'9','-','_'] THEN
        BID:=BID+S[B]
      ELSE
      IF S[b]=' ' THEN
        STATE:=10
      ELSE
        Fehler('Invalid character in BID: '+S[b]);
      GOTO Weiter;
    END;
    IF STATE=4 THEN
    (* rubrik *)
    BEGIN
      IF (Upcase(S[B]) IN ['A'..'Z','0'..'9','-','_'] THEN
        Rubrik:=Rubrik+UPCASE(S[B])
      ELSE
      IF S[b]=' ' THEN
        STATE:=5
      ELSE
        Fehler('Invalid character in Boardname: '+S[b]);
      GOTO Weiter;
    END;
    IF STATE=5 THEN
    (* aha, rubrik wurde schon angeben... *)
    BEGI2N
      (* Leerzeichen berlesen... *)
      IF S[B]=' ' THEN GOTO Weiter;
      IF (S[B]<'9') AND (S[B]>'0') THEN
         STATE:=6
      ELSE
      IF (S[B]='"') THEN
      BEGIN
         STATE:=7
         GOTO Weiter;
      END
      ELSE
      IF (S[B]="-") THEN
      BEGIN
        STATE:=9
        GOTO Weiter;
      END
      ELSE
      BEGIN
        Fehler('expected: ",-,BLANK,0-9 found:  '+S[b]);
        Goto Weiter;
      END;
    END;
    IF (STATE=2) OR (STATE=7) THEN
    (* aha, ein suchbegriff in "..." wurde angegeben *)
    BEGIN
      IF S[B]='"' THEN
      BEGIN
        IF S[B-1]='\' THEN
          SUCH:=SUCH+'"'
        ELSE STATE:=5;
      END ELSE
        SUCH:=SUCH+S[b];
      GOTO Weiter;
    END;
    IF STATE=6 THEN
    (* soso, die start-nummer *)
    BEGIN
      IF (S[B]<'9') AND (S[B]>'0') THEN
      BEGIN
        tmp:=tmp+S[B];
        VAL(tmp,long,err);
        IF (long>$FFFF) THEN
          Fehler('Value out of range');
      END ELSE
      IF S[B]=' ' THEN
      BEGIN
        STATE:=8;
        Val(tmp,start,err);
        tmp:='';
      END
      ELSE
      IF (S[B]='-') THEN
      BEGIN
         STATE:=9;
         Val(tmp,start,err);
         tmp:='';
      END ELSE
        Fehler('Parse error!');
      Goto Weiter;
    END;
    IF STATE=8 THEN
    BEGIN
      IF S[B]=' ' THEN GOTO Weiter;
      IF S[B]='-' THEN
        STATE:=11
      ELSE
      IF S[B]='"' THEN
        STATE:=7
      ELSE
      IF ((Upcase(S[B])<'Z') AND (Upcase(S[b])>'A') OR
         ((S[B]<'9') AND (S[b]>'0')) AND (TYP=1) THEN
      BEGIN
        STATE:=10;
        GOTO VonVorne;
      END ELSE
        Fehler('expected: ["- ], found:'+s[b]);
      GOTO Weiter;
    END;
    IF STATE=11 THEN
    (* aha ein - wurde angegeben, es sollte stop-nr kommen,
       knnen aber auch spaces sein *)
    BEGIN
      IF S[b]=' ' THEN GOTO Weiter;
      IF (S[B]<'9') AND (S[B]>'0') THEN
        STATE:=9
      ELSE
      BEGIN
        Fehler('numerical value expected');
        GOTO Weiter;
      END;
    END;
    IF STATE=9 THEN
    BEGIN
    (* soso, die stop-nummer *)
    BEGIN
      IF (S[B]<'9') AND (S[B]>'0') THEN
      BEGIN
        tmp:=tmp+S[B];
        VAL(tmp,long,err);
        IF (long>$FFFF) THEN
          Fehler('Value out of range');
      END ELSE
      IF S[B]=' ' THEN
      BEGIN
        STATE:=8;
        Val(tmp,stop,err);
        IF stop=0 THEN
          Fehler('Value out of range');
        tmp:='';
      END
      ELSE
      END ELSE
        Fehler('numerical value expected.');
      GOTO Weiter;
    END ELSE
    IF STATE=10 THEN
    (* so, die mail-auswahl ist beendet, jetzt kommt die
       rubrik und der verteiler, wo hintransferiert werden soll *)
    BEGIN
      IF typ=0 THEN Fehler("
  weiter:
  END;
  (* so, j






END;


