{ $A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X-,Y+}
{ $M 16384,0,655360}
{$R-}
USES portpas,crt;

TYPE TP_WORD = ^WORD;
     TP_CHAR = ^CHAR;
     ByteARR=ARRAY[0..$FFF0] OF BYTE;

CONST CR=#13;
      cBIN='#BIN#';
      cOK='#OK#';
	FEND :CHAR= #$C0;  {* KISS-Konstante: FrameEND *}
	FESC :CHAR= #$DB;  {* KISS-Konstante: FrameESCape *}
	TFEND:CHAR= #$DC;  {* KISS-Konstante: Transponiertes FrameEND *}
	TFESC:CHAR= #$DD;  {* KISS-Konstante: Transponiertes FrameESCape *}
      cMAXBLOCKSIZE=8192;

      cIdInfo  = 1;
      cIdStart = 2;
      cidERR   = 3;
      cidDATA  = 4;
      cidFIN   = 5;
      cidREQ   = 6;
      cidFINACK= 7;
      cidBINALT= 99;
      nErrors:LONGINT=0;
      ErrorRate:BYTE=0;
      ByteLost:BYTE=0;
      IntrudingStrings:BYTE=0;
      ByteChanges:BYTE=0;

TYPE T_BlockID=Word;
     T_Block=RECORD
	       fValid  : BOOLEAN;
	       blockID : T_BlockID;
	       inUse,
	       lenData : longint;
	       pData   : Pointer;
	       crc     : Word;
	      END;

     T_Node=(cSERVER,cCLIENT);
     TP_BUF=^T_BUF;
     T_BUF=RECORD
	     pData : POINTER;
	     Len : Longint;
	     start : Longint;
	     next : tp_buf;
	   END;

VAR fEnde : BOOLEAN;

    apRoot,
    apTail : ARRAY[T_NODE] OF TP_BUF;
    size : ARRAY[T_NODE] OF Longint;


{----------------------------------------------------------------------------}

PROCEDURE BinCalcCRC (p : Pointer; len : WORD; VAR ulCRC:WORD);
{* crc-Berechnung #bin# maessig. von dh1dae *}
VAR
  HiBit : Boolean;
  Shift : Integer;
  i     : WORD;
BEGIN
  FOR i := 1 TO len DO
    BEGIN
    Shift := $80;
    REPEAT
      HiBit := ulCRC AND $8000 > 0;
      ulCRC := ulCRC Shl 1;
      {$R-}
      IF (byte(p^) AND Shift) > 0 THEN ulCRC := ulCRC OR 1;
      IF HiBit THEN ulCRC := ulCRC XOR $1021;
      Shift := Shift SHR 1;
    UNTIL Shift = 0;
    Incp1 (p); {* Au weia... *}
    END;
END;

FUNCTION CalcFileCRC(sFN:STRING):Word;
var
  FromF : file;
  ulCRC,
  NumRead: Word;
  Buf: array[1..2048] of Char;
begin
  Assign(FromF, sFN); { Open input file }
  Reset(FromF, 1);  { Record size = 1 }
  ulCRC := 0;
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    BinCalcCRC (@buf, numRead ,ulCRC);
  until (NumRead = 0);
  Close(FromF);
  calcFileCrc := ulCRC;
END;

{-------------------------------------------------------------------}


PROCEDURE SendTo( recv : T_Node; pBuf:pointer; lenBuf : longint );
  VAR n : tp_buf;entropystart:LONGINT;p:Pointer;b:BYTE;
BEGIN
  {* Immer in der QUEUE des anderen ablegen *}
  IF recv=cSERVER THEN recv:=cCLIENT
		  ELSE recv:=cSERVER;

  GetMem(n, sizeof(n^));
  GetMem(n^.pData,lenBuf);
  n^.len := lenBuf;
  n^.start := 0;
  n^.next := nil;
  Move(pBuf^, n^.pData^, lenBuf);
  if ByteChanges>0 THEN
  BEGIN
    IF Random(100-ByteChanges)=1 THEN
    BEGIN
      EntropyStart:=random(word(lenbuf mod $FFFF)-2);
      p:=n^.pdata;
      B:=ByteARR(p^)[EntropyStart];
      ByteARR(p^)[EntropyStart]:=ByteArr(p^)[EntropyStart+1];
      ByteArr(p^)[EntropyStart+1]:=B;
     END;
  END;
  IF apRoot[recv]=nil THEN apRoot[recv] := n
		      ELSE apTail[recv]^.next := n;
  apTail[recv] := n;
  Inc(size[recv],lenBuf);
END;


PROCEDURE ReceiveFrom( tx : T_Node; stopch:char; pBuf:pointer; lenBuf:longint; VAR written : longint );
  VAR p : Pointer;
      pc : ^CHAR;
      i,
      nW : Longint;
      fStop : BOOLEAN;
BEGIN
  written := 0;

  WHILE True do
    BEGIN
    IF apRoot[tx] = nil THEN Exit;
    WITH aproot[tx]^ DO
      BEGIN
      IF Written >= lenBuf THEN Exit;
      IF len-start > 0
	THEN BEGIN
	     IF lenBuf-written>len-start
	       THEN nw := len-start
	       ELSE nW := lenBuf-written;
	     fStop := false;
	     IF stopch<>#0 THEN
	       BEGIN
	       pc := pData;
	       Incpn(pc, start);
	       FOR i := 1 to nw DO
		 BEGIN
		 IF pc^ = stopch THEN BEGIN nw := i; fStop := true; break; END;
		 Incp1(pc);
		 END;
	       END;
	     pc := pData;
	     Incpn(pc, start);
	     Move( pc^ ,pBuf^, nw );
	     start := start + nw;
	     Dec(size[tx],nw);
	     Inc(written,nw);
	     IF fStop THEN Exit;
	     END
	ELSE BEGIN {* Neuen Block holen, alter ist aufgebraucht *}
	     p := next;
	     FreeMem(pData,len);
	     FreeMem(aproot[tx],sizeof(aproot[tx]));
	     aproot[tx] := p;
	     END;
      END;
    END;

END;



PROCEDURE SendLineTo( recv : T_Node;  s:String  );
BEGIN
  SendTo(recv, @s[1], length(s));
END;


var x,y : BYTE;
{ $IFDEF X}


FUNCTION ReceiveLineFrom( sel : T_NODE; VAR s : STRING) : BOOLEAN;
  VAR c : CHAR;
      written : LongInt;
BEGIN
  ReceiveLineFrom := False;
  REPEAT
    ReceiveFrom( sel, #13, @s[length(s)+1], sizeof(s)-1-length(s), written );
   byte(s[0]):=ord(s[0])+written;
    {    ReceiveFrom( sel, #0, @c,1, written ); }
    IF written>0 THEN
      BEGIN
      IF s[length(s)]=CR THEN BEGIN
		     Delete(s,length(s),1);
		     Window(40,1,79,10);
		     Gotoxy(x,y);
		     WriteLn(s);
		     x := WhereX;
		     y := WhereY;
		     Window(1,1,80,25);
		     ReceiveLineFrom := true;
		     Exit;
		     END;
      END;
  UNTIL written=0;
END;
{ $ENDIF}


PROCEDURE SendBlockTo ( recv : T_Node; blockid: T_blockid; pBuf:pointer; lenBuf : longint );
  VAR i : LongInt;
      state : BYTE;
      pc : ^CHAR;
      ulCRC : WORD;
      sSend : STRING;

   PROCEDURE EscapeIt(c:char);
   BEGIN
     IF      (c = FEND) THEN sSend := sSend + FESC + TFEND
     ELSE IF (c = FESC) THEN sSend := sSend + FESC + TFESC
     ELSE sSend := sSend + c;
   END;

BEGIN
  ulCRC := 0;
  BinCalcCRC (@blockID, sizeof(blockID), ulCRC );
  BinCalcCRC (pBuf, lenbuf, ulCRC );

  sSend := fEND+char(lo(blockID))+char(hi(blockid));
  pc := pBuf;
  FOR i := 1 TO lenBuf DO
    BEGIN
    EscapeIt(pc^);
    IF length(sSend) > 200 THEN
      BEGIN
      SendTo(recv, @sSend[1], length(sSend) );
      sSend := '';
      END;
    Incp1(pc);
    END;
  EscapeIt( char(lo(ulCRC)) );
  EscapeIt( char(hi(ulCRC)) );

  sSend := sSend + FEND;
  SendTo(recv, @sSend[1], length(sSend) );
END;

PROCEDURE FreeRxBlock (VAR Block:T_Block);
BEGIN
  IF NOT block.fValid THEN Exit;
  FreeMem(block.pData, block.lenData);
  block.pData := nil;
  block.lenData := 0;
  block.inUse := 0;
END;


PROCEDURE ReceiveBlockFrom ( tx : T_Node; fIgnoreJunk : BOOLEAN; VAR block:T_Block);
  CONST MAXROHBLOCKSIZE=2*cMaxBlockSize+100;
  VAR pBlock : Pointer;
      fErr : BOOLEAN;
      pDest, pc : ^CHAR;
      c:Char;
      pw : ^WORD;
      lWritten, n : Longint;
BEGIN
  block.inUse := 0;
  block.fValid := false;
  block.lenData := 0;
  block.pData := nil;

  IF size[tx] = 0 THEN Exit;
  GetMem(pBlock, MAXROHBLOCKSIZE );
  IF fIgnoreJunk
    THEN BEGIN
	 Repeat
	   ReceiveFrom( tx, FEND , pBlock, MAXROHBLOCKSIZE, lwritten );
	 Until tp_char(pBlock)^=FEND;
	 END
    ELSE BEGIN
	 ReceiveFrom( tx, FEND , pBlock, 1, lwritten );
	 IF (tp_char(pBlock)^<>FEND) AND (lWritten>0) THEN
	   BEGIN {* Ist kein Block (kein FEND am Anfang), sondern rohe Daten, Sonderlocke wg. BIN-Fallback *}
	   block.fValid := true;
	   block.blockID := cidBINALT;
	   block.pData := pBlock;
	   block.lenData := MAXROHBLOCKSIZE;
	   block.inUse := lWritten;
	   Exit;
	   END;
	 END;
  ReceiveFrom( tx, FEND , pBlock, MAXROHBLOCKSIZE, lwritten );

  pc := pBlocK;
  n := lWritten;

  {* pc zeigt nun auf auf das erste Zeichen nach BOB *}
  block.lenData := n;
  GetMem(block.pData, block.lenData);

  fErr := FALSE;
  pDest := block.pData;
  WHILE (pc^<>FEND) AND (n>0) AND NOT fErr DO
    BEGIN
    IF pc^= FESC THEN BEGIN
		      Incp1(pc); Dec(n);
		      IF      (pc^=tfend) THEN c := fend
		      ELSE IF (pc^=tfesc) THEN c := fesc
		      ELSE fErr := true;
		      END
		 ELSE c := pc^;
    pDest^ := c;
    Incp1(pDest); Inc(block.inUse);
    Incp1(pc); Dec(n);
    END;

  block.fValid := (pc^=FEND) AND NOT fErr AND (block.inUse >= 2);
  GotoXY(1,24);
  if NOT block.fvalid THEN  Write('Error in Block':20)
  ELSE Write('Block extraction ok':20);
  IF block.fValid THEN
    BEGIN {crc etc. drfen erst nach dem entstuffen geholt werden}
    Dec(block.inUse,2);
    block.CRC:=0;
    BinCalcCRC( block.pData, block.inUse, block.CRC);
    pc := block.pData;
    Incpn(pc, block.inUse);
    pw := pointer(pc);
    block.fValid := pw^=block.CRC;
    block.blockID := tp_word(pointer(block.pData))^;
    END;
  GotoXY(22,24);
  if NOT block.fvalid THEN  Write('Error in Block-CRC')
  ELSE Write('Block-CRC ok');
 ClrEOL;
  FreeMem(pBlock, MAXROHBLOCKSIZE );
END;



{-----------------------------------------------------------------------}


PROCEDURE DoClient;
 CONST cstate : (cNIL,cSTARTBIN,cENDBIN,
		     cSTARTr, cWait_r_Data  ) = cNIL;
       sState:ARRAY[0..4] OF STRING=('NIL','STARTBIN','ENDBIN','STARTR','WAITDATA');         
       lenRecv  :Longint=0;
       nTimeWait:Longint=0;
       nRecv : Longint=0;
       expCRC : WORD=0;
       sZeile : STRING='';
  VAR cbuf: array[1..204] of Char;
      s : STRING;
      Written : Longint;
      i : BYTE;
      ulCRC : WORD;
      Block : T_Block;
BEGIN
    GotoXY (1,20);
    Write('State: ',sstate[ord(cstate)]:8, '  Recv:',nRecv:7,  '  CRC:',ulCRC:6, '  Q:',size[cCLIENT]);
    ClrEol;
    GotoXY (1,21);
    Write('   to',    nTimeWait:4 ,' eRecv:',lenRecv:7,' eCRC:',expCRC:6,' Errors:',nErrors:5);
    ClrEol;
    GotoXY (1,22);
    ClrEol;

    case cstate of
      cNil : BEGIN
	     IF ReceiveLineFrom(cSERVER,sZeile) THEN
	       BEGIN
	       IF Copy(sZeile,1,5)='#BIN#' THEN
		 BEGIN
		 {* Dateilnge rausziehen *}
		 lenRecv := 0; i:=6;
		 WHILE (sZeile[i]>='0') AND (sZeile[i]<='9') AND (i<=length(sZeile)) DO
		   BEGIN
		   lenRecv := lenRecv*10 + ord(sZeile[i])-48;
		   Inc(i);
		   END;
		 {* CRC rausziehen *}
		 expCRC := 0; Inc(i);
		 IF sZeile[i] = '|' THEN
		   BEGIN
		   Inc(i);
		   WHILE (sZeile[i]>='0') AND (sZeile[i]<='9') AND (i<=length(sZeile)) DO
		     BEGIN
		     expCRC:= expCRC*10 + ord(sZeile[i])-48;
		     Inc(i);
		     END;
		   END;
		 sZeile := '';
		 nRecv := 0;
		 ulCRC := 0;
		 nTimeWait := 0;

  {              cstate:=cSTARTBIN;
		 SendLineTo(cSERVER, '#OK#'+CR);
  }
		 SendLineTo(cSERVER, '#DIDADIT#'+CR+'#OK#'+CR);
		 cstate:=cSTARTR;
		 END;
	       END;
	     END;

      cStartR
	   : BEGIN {warte auf Infoblock vom Server}
	     ReceiveBlockFrom ( cServer, false, block );
	     IF (block.inUse > 0) AND block.fValid THEN
	       BEGIN
	       CASE block.blockid OF
		  cidBINALT : { $TODO };
		  cidINFO :
		      BEGIN
		      IF block.blockid=cidINFO
			 THEN BEGIN
			      {InfoBlock auswerten}
			      {...}
			      {StartBlock senden}
			      s := 'OFFSET=0'+CR
				 + 'MD5=1234'+CR
				 + 'BLOCKSIZE=1000'+CR
				 + 'VERSION=0.5'+CR
				 ;
			      SendBlockTo(cServer, cidSTART, @s[1], length(s) );
			      cstate := cWait_R_Data;
			      END
			 ELSE BEGIN
			      s := '402 Sonstiger Fehler'+CR;
			      SendBlockTo(cServer, cidERR, @s[1], length(s) );
			      END;
		      END;
		 ELSE {case} {Handle defaultblocks}
		 END{case};
	       END;
	     FreeRxBlock(block);
	     END;
       cWait_R_DAta
	   : BEGIN
	     ReceiveBlockFrom ( cServer, true, block );
	     IF block.fvalid THEN
	     BEGIN
	       IF      block.blockid=cidDATA THEN Inc(nRecv, block.inUse)
	       ELSE IF block.blockid=cidFIN  THEN
		 BEGIN
		 SendBlockTo( cServer, cidFINACK, nil, 0);
		 cState := cNil;
		 END;
	     END ELSE inc(nErrors);
	     FreeRxBlock(block);
	     END;

      cStartBIN
	   : BEGIN
	     ReceiveFrom( cSERVER, #0, @cbuf, sizeof(cBuf), written );
	     IF written=0
	       THEN Inc(nTimeWait)
	       ELSE BEGIN
{                    IF Random(100)<11 THEN
		      BEGIN
		      Dec(written);
		      Inc(written);
		      cBuf[1] := '1';
		      END;}
		    END;
	     BinCalcCrc( @cBuf, written, ulCRC );
	     Inc(nRecv,written);
	     IF nRecv>=lenRecv THEN cState := cENDBIN;
	     END;
      cENDBIN
	   : BEGIN
	     END;
     END;
END;





PROCEDURE DoServer; 
  CONST cTXBLOCKSIZE=1024;
    sstate :(cNil, cINIT, cWaitForOK,
		cSENDDATA, cENDData,
	       cWaitForStartBlock, cSEND_R_DATA, cFIN)= cINIT;
    StateStrings:ARRAY[0..6] OF STRING=
    ('NIL','INIT','WAIT_OK','SEND_DATA','WAIT_START','SEND_DATA','FIN');
    fClientKannR :Boolean= false;
    sBinStr : String = '';
    sCRC    : String = '';
    sLine   : String='';

  VAR sbuf: array[1..2048] of Char;
      nTxed, written,
      currOffset : LongInt;
      f : File;
      sLen : STRING;
      NumRead : Word;
      Block : T_Block;

    PROCEDURE HandleAllgBlock(Block:T_Block);
    BEGIN
    END;

BEGIN
    GotoXY (1,19); Write('State: ',StateStrings[ord(sstate)]:8,
			 '  Txed:',nTxed:7,
			 ' sCRC:',sCRC:6,
			 '  Q:',size[cSERVER], '    ',
			 sBinStr:25 );
    ClrEol;
    case sstate of
      cNil : ;
      cINIT :BEGIN
	     Assign(f,'test.bin');
	     Reset(f,1);
	     Str(filesize(f),sLen);
	     close(f);
	     Str(CalcFileCRC('test.bin'),sCrc);
	     sBinStr := '#BIN#'+sLen+'#'+'|'+sCRC;
	     SendLineTo(cClient, sBinStr+CR );
	     sstate := cWaitForOK
	     END;
      cWaitForOK
	   : BEGIN
	     IF ReceiveLineFrom(cClient,sLine) THEN
	       BEGIN
	       IF sLine = '#DIDADIT#' THEN fClientKannR := true;
	       IF sLine = '#OK#' THEN
		 IF fClientKannR
		   THEN BEGIN {* Sende InfoBlock *}
			sLine := 'FILENAME=TEST.BIN'+cr
				+'SIZE='+sLen+cr
				+'MD5='+sCRC+CR
				+'TIME=8000000'+CR
				+'BLOCKSIZE=1024'+CR
				+'VERSION=0.5'+CR
				;
			SendBlockTo ( cCLIENT, cidINFO, @sLine[1], length(sLine) );
			sstate := cWaitForStartBlock;
			END
		   ELSE BEGIN
			sstate:=cSENDDATA;
			currOffset := 0;
			Assign(f,'test.bin');
			Reset(f,1);
			nTxed := 0;
			END;
	       sLine := '';
	       END;
	     END;
      cWaitForStartBlock :
	    BEGIN
	    ReceiveBlockFrom ( cCLIENT, true , Block);
	    IF (block.inUse>0) AND block.fValid THEN
	      IF block.blockID <> cidSTART
		THEN HandleAllgBlock(Block)
		ELSE BEGIN
		     sstate := cSEND_R_Data;
		     currOffset := 0;
		     Assign(f,'test.bin');
		     Reset(f,1);
		     nTxed := 0;
		     END;
	    FreeRxBlock(block);
	    END;
      cSEND_R_Data
	   : BEGIN
	     sBuf[1] := char(nTxed and $FF);
	     sBuf[2] := char((nTxed SHR  8) and $FF);
	     sBuf[3] := char((nTxed SHR 16) and $FF);
	     sBuf[4] := char((nTxed SHR 24) and $FF);
	     sBuf[5] := char(lo(cTXBLOCKSIZE));
	     sBuf[6] := char(hi(cTXBLOCKSIZE));
	     BlockRead(f, sBuf[7], SizeOf(sBuf)-6, NumRead);
	     SendBlockTo ( cCLIENT, cidDATA, @sBuf, 6+NumRead );
	     Inc(nTxed,numRead);
	     IF (NumRead = 0) THEN
	       BEGIN
	       SendBlockTo ( cCLIENT, cidFIN, nil, 0 );
	       sState := cFIN;
	       END;
	     END;
      cFIN : BEGIN
	     {Warte auf Reaktion des Clients}
	     ReceiveBlockFrom ( cCLIENT, true , Block);
	     IF (block.inUse>0) AND block.fValid THEN
	       BEGIN
	       IF      block.blockID = cidFINACK THEN BEGIN sState := cNil; close(f); END
	       ELSE IF block.blockID = cidREQ THEN
		 BEGIN
		 {Request beahddeln}
		 END;
	       END;
	     FreeRxBlock(block);
	     END;

      cSENDDATA
	   : BEGIN
	     BlockRead(f, sBuf, SizeOf(sBuf), NumRead);
	     SendTo( cCLIENT, @sBuf, NumRead );
	     Inc(nTxed,numRead);
	     IF (NumRead = 0) THEN sState := cENDDATA;
	     END;
      cENDDATA
	   : BEGIN
	     close(f);
	     sstate := cNil;
	     END;
       END;

END;


{-----------------------------------------------------}



  VAR i : WORD;
BEGIN
  Randomize;
  FillChar(apRoot,sizeof(apRoot), #0);
  FillChar(apTail,sizeof(apRoot), #0);
  FillChar(size  ,sizeof(size  ), #0);

  fEnde := false;
  ClrScr;

  While not fEnde AND not keypressed DO
    BEGIN
    GotoXY(1,1);
    Write(Maxavail);
    clreol;

    DoServer;
    delay(100);
    DoClient;
    END;
END.





{

DG9EP @DB0IZ     de:DG4IAD 25.11.97 22:55 UTC   5400 Bytes
(EBIN 25) Aktuelle Zusammenfassung


971125/2254z DB0RWI, 971125/2253z DB0HOM, 971125/2240z DB0RBS
971125/2226z DB0LX , 971125/2248z DB0PRT
From: DG4IAD @ DB0PRT.#BW.DEU.EU
To:   DG9EP @ DB0IZ.#NRW.DEU.EU
X-Info: Mail generated by mailing list server
X-MID: PB7DB0PRT0OZ


Description: Diskussion um Filetransferprotokolle

Maintainers (1):
DG4IAD

Users (11):
DD6ZJ  DG4MMI DG6VJ  DG8NJY DG9EP  DG9OBU DH1DAE DH2MBM DL1NC  DL3MGQ DL5MLO 
-------------------------------------------------------------------------------
From: DG4IAD @ DB0ZDF.#RPL.DEU.EU  (Hans-Peter)
To  : DB0PRT @ DB0PRT.#BW.DEU.EU
X-Info: No login password

Hallo,
da mir im Moment etwas die Zeit fehlt, nur eine etwas angepasste Version
des alten Files. Es sollte evtl nochmal eine Protokoll-Ablauf Tabelle wie
in Reinalds Vorschlag gemacht werden (Reinald?). Ansonsten nochmal genau
durchlesen, ich habe sicher etwas vergessen. Wir muessen dann noch den
verwendeten CRC und die Blocktyp-IDs definieren. Bei letzterem wuerde ich
einfach von 1 an durchzaehlen, so wie sie in der nachfolgenden Spec
auftauchen. Ausserdem bitte mal kommentieren, wie dann die endgueltige (?)
Spezifikation formal aussehen sollte. Was muss rein, was nicht? Irgendein
Werbefachmann anwesend ? :-)
Also denn mal los,
Gruss, HP
----
Das DIDADIT - Protokoll. (R)
(Abk.f.: Data Is Data And Data Is Transferable)

V0.5

Annahmen:
  Saemtlichen binaeren Zahlen im Big-Endian (Intel) Format.
  Saemtliche alphanumerischen Strings im ISO Zeichensatz.

Grundaufbau:

  Die Daten werden Rahmenweise uebertragen. Jeder Rahmen besteht
  aus einem Rahmen-Ende-Markierung, fortan EOB, den Daten und
  einem CRC. Der Inhalt dieser Rahmen inklusive Daten wird
  nach dem SLIP/KISS-Verfahren gestufft. Der CRC ist also
  obligatorisch und bei jedem Rahmen dabei.
  Vorbelegung des CRC und das Polynom ist noch zu spezifizieren.
  <EOB><DATA><CRC><EOB>


Die Block-Typen:

  In R sind die ersten 2 Byte eines Rahmens immer die
  Block-Type. Dieser identifiziert die Art der darauf folgenden
  Daten.
  <TYPE><DATEN>

Fuer alle Block-Typen ausser DATA muss ein Antwort-Block definiert sein.
Vor Eintreffen der erwarteten Reaktion darf kein anderer nicht-DATA
Block gesendet werden. Bleibt die Reaktion aus, so wird der nach einem
festzulegenden Timeout wiederholt. Nach 5 Wiederholungen wird die Verbindung
getrennt.


INFO:
  Der Block enthaelt eine Reihe von ID=WERT-Paaren, die jeweils
  durch CR abgeschlossen sind.
  Bisher definiert: FILENAME,PATH,SIZE,MD5,TIME,BLOCKSIZE,VERSION.
  TIME ist Dezimal als Epoch-Time (sek nach '70) in ascii anzugeben.

Reaktion: START/REFUSE


START:

  Ersetzt das #EOK# aus der ersten Draft.
  Diese Spezifikation definiert fuer den Anfang:
  OFFSET=<num.wert>  als Offset fuer den Resume.
  MD5=<hex-wert>     MD5-Hash von start-offset, um sicher
		     zu stellen, dass es sich noch um die gleiche
		     Datei handelt.
  BLOCKSIZE          Falls der vom Sender in INIT vorgeschlagene
		     Wert zu hoch sein sollte.
  VERSION

Reaktion: DATA/FIN

REFUSE:
  Ersetzt das #NO# aus Autobin.
  Der Block enthaelt die Begruendung im Klartext, mit einem
  vorrangestellten Fehlercode. 
  z.b."205 File not found".

Reaktion: Disconnect/Protokoll-Ende


DATA:

  Ein Block vom Typ DATA enthaelt folgende Informationen
  4 Bytes Offset
  2 Bytes Blocklaenge.
  0-0xFFFF Bytes Daten.
  <OFFSET><LEN><DATA>

Reaktion: nicht erforderlich

REQ:
  
  Ein REQ-Block fordert einen bestimmten Teil der Datei erneut
  an. Dies kann an jeder Stelle der Uebertragung geschehen,
  wird aber beim normalen Filetransfer erst am Ende der
  Uebertragung stattfinden.
  4 Bytes Offset.
  2 Bytes Blocklaenge.

Reaktion: DATA/ERR

FIN:
  
  Wenn die Datei komplett uebertragen ist, schickt der Sender einen
  FIN-Block. Dieser enthaelt optional ein Daten-Feld, das aber
  zunaechst nicht spezifiziert wird. Nach Empfang des FIN ueberprueft
  der Empfaenger, ob ihm Teile fehlen und fordert diese gegebenfalls
  mittels REQ an.

Reaktion: REQ/FIN-ACK


FIN-ACK:

  Hat der Client alle Daten vollstaendig, so beendet er den Transfer
  durch einen FIN-ACK.

Reaktion: Protokoll-Ende.

TYPREJ:

  Beim Empfang eines solchen Blockes muss sofort mit der weiteren
  Aussendungen weiterer Bloecke vom <TYP> einzustellen.
  1 Byte zurueckgewiesener Typ

Reaktion: zu definieren?

ECHO-REQUEST:
 
  Enthaelt beliebige Daten, die mit dem Block-Typ ECHO-REPLY
  zurueckgeschickt werden muessen.

Reaktion: ECHO-REPLY

ECHO-REPLY:

  s.ECHO-REQUEST

Reaktion: schon wieder eine Ausnahme?

Das Protokoll wird durch einen normalen Autobin-Header eingeleitet.
Beherrscht der Client R, so schickt er 2 Zeilen zurueck:
#..-.#
#OK#
Daraufhin schickt der Server einen INFO-Block, auf den der Client mit
START antwortet.
Ist der Server _nicht_ R-faehig, so muss der Client erkennen, dass es
sich um keine gueltigen R-Bloecke handelt und einen Fallback auf
Autobin durchfuehren.
}
