UNIT PGP;
INTERFACE

PROCEDURE pgpSetdlg;
PROCEDURE pgpSetdlg_auswert;
PROCEDURE pgpSendPKdlg;
PROCEDURE pgpSendPKdlg_auswert;
PROCEDURE pgpGenKeydlg;
PROCEDURE pgpGenKeydlg_auswert;
PROCEDURE pgpEditTrustdlg;
PROCEDURE pgpEditTrustdlg_auswert;
PROCEDURE pgpCertifydlg;
PROCEDURE pgpCertifydlg_auswert;

IMPLEMENTATION
USES IADVAR,INPUT,TOOLBOX,CRT,DOS
,{$IFNDEF LINUX}MEMORY,{$ENDIF}SCREEN,BOXUTIL,BOXMAIN;

VAR Absender,Empfaenger,Verteiler:STRING[8];
CONST PGP_USER_NAME:STRING='';P2:STRING='';
PROCEDURE pgpSetdlg;
BEGIN
  Which_Dialog:=30;
  DlgCheck(2,2,20,'Check signatures',@CHECK_PGP_SIG);
  DlgCheck(2,3,20,'Collect Public keys',@SAVE_PUBLIC_KEYS);
  DlgOkButton(2,4,1,'  OK   ');
  DlgAbortButton(12,4,'CANCEL');
  DlgTitle('PGP Settings');
  DlgInit(10,5,1)
END;

PROCEDURE pgpSetdlg_auswert;
BEGIN
  Which_Dialog:=0;
END;

PROCEDURE PgpSendPKDlg;
BEGIN
  Which_Dialog:=31;
  IF Absender='' THEN absender:=cutssid(mycall);
  Absender:=cutssid(mycall);
  Empfaenger:='PGP';
  Verteiler:='DL';
  DlgStr(20,2,8,@absender);
  DlgLabel(2,2,18,'Sender');
  DlgStr(20,3,8,@empfaenger);
  DlgLabel(2,3,18,'Board/Reciepent');
  DlgText(29,3,'@');
  DlgStr(31,3,8,@verteiler);
  IF PGP_USER_NAME='' THEN
     PGP_USER_NAME:=klein(cutssid(mycall));
  DlgStr(22,7,20,@PGP_USER_NAME);
  DlgLabel(2,7,20,'PGP username:');
  DlgOkButton(2,8,1,'  OK   ');
  DlgAbortButton(12,8,'CANCEL');
  DlgTitle(' Distribute Public Key');
  DlgInit(10,10,3);
END;

PROCEDURE PGPSendPKDlg_Auswert;
VAR f,f2:text;W:WORD;S:STRING;

BEGIN
  Which_Dialog:=0;
  IF DLgResult=0 THEN exit;
  {$I-}
  ASSIGN(f2,temppath+'pgp.ASC');
  ERASE(f2);
  IF IORESULT<>0 THEN;
  S:=' +force +batchmode -kxa '+PGP_USER_NAME+' '+temppath+'PGP.tmp';
   ClrScr;
  {$IFNDEF LINUX ;
  SetMemTop(HeapPtr);
  SwapVectors;
  EXEC(GETENV('PGPPATH')+'PGP.EXE',S);
  SwapVectors;
  SetMemTop(HeapEnd);
   {$ENDIF}
  IF ReadKey=#0 then;
  IF IORESULt<>0 THEN WRITE(#7);
  Redrawscreen;
  If NOT FileDa(temppath+'PGP.ASC') THEN exit;
  ASSIGN(f,boxpath+'import'+PATH_SEP+finduniqueimportfilename);
  
  REWRITE(f);
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('I/O Error');
    exit;
  END;
  WriteLn(f,'S '+gross(empfaenger),' @ ',gross(verteiler),' < ',gross(absender));
  WriteLn(f,'Public Key '+PGP_USER_NAME);
  WriteLn(f);
  WriteLn(f,'From : ',gross(absender),' @ ',gross(cutssid(boxcall)));
  WriteLn(f,'To   : ',gross(empfaenger),' @ ',gross(verteiler));
  WriteLn(f);
  ASSIGN(f2,temppath+'pgp.ASC');
  RESET(f2);
  IF IORESULT<>0 THEN
  BEGIN
     CLOSE(f);ERASE(f);EXIT;
  END;
  WHILE NOT EOF(f2) DO
  BEGIN
    READLN(f2,s);
    WRITELN(f,s);
  END;
  CLOSE(f2);
  ERASE(F2);
  IF IORESULT<>0 THEN;
  CLOSE(F);
  IF IORESULT<>0 THEN;
  PopUp(' On the way ');
  Box_NewMail;
  {$I+}
END;

PROCEDURE PgpGenKeyDlg;
BEGIN
  {$IFNDEF LINUX} 
  SetMemTop(HeapPtr);
  SwapVectors;
  EXEC(GETENV('PGPPATH')+'PGP.EXE','-kg');
  SwapVectors;
  SetMemTop(HeapEnd);
   {$ENDIF}
  IF IORESULt<>0 THEN WRITE(#7);
  Redrawscreen;
END;

PROCEDURE PGPGenKeyDlg_Auswert;
BEGIN
END;

PROCEDURE PgpEditTrustDlg;
BEGIN
  Which_Dialog:=32;
  IF PGP_USER_NAME='' THEN
     PGP_USER_NAME:=klein(cutssid(mycall));
  DlgStr(22,2,20,@PGP_USER_NAME);
  DlgLabel(2,2,20,'PGP username:');
  DlgOkButton(2,3,1,'  OK   ');
  DlgAbortButton(12,3,'CANCEL');
  DlgTitle(' Edit someones Trust Parameters ...');
  DlgInit(10,10,1);
END;

PROCEDURE PGPEditTrustDlg_Auswert;
VAR f,f2:text;W:WORD;S:STRING;

BEGIN
  Which_Dialog:=0;
  IF DLgResult=0 THEN exit;
  S:=' -ke '+PGP_USER_NAME;
  ClrScr;
   {$IFNDEF LINUX}
  SetMemTop(HeapPtr);
  SwapVectors;
  EXEC(GETENV('PGPPATH')+'PGP.EXE',S);
  SwapVectors;
  SetMemTop(HeapEnd);
   {$ENDIF}
  IF IORESULt<>0 THEN WRITE(#7);
  Redrawscreen;
END;


PROCEDURE PgpCertifyDlg;
BEGIN
  Which_Dialog:=33;
  IF PGP_USER_NAME='' THEN
     PGP_USER_NAME:=klein(cutssid(mycall));
  DlgStr(29,2,20,@PGP_USER_NAME);
  DlgLabel(2,2,27,'Your PGP username     :');
  DlgStr(29,3,20,@p2);
  DlgLabel(2,3,27,'User-ID of Key to sign:');
  DlgOkButton(2,4,1,'  OK   ');
  DlgAbortButton(12,4,'CANCEL');
  DlgTitle(' Certify someones Public key ...');
  DlgInit(10,10,3);
END;

PROCEDURE PGPCertifyDlg_Auswert;
VAR f,f2:text;W:WORD;S:STRING;
{LABEL spagetti;}
BEGIN
  Which_Dialog:=0;
  IF DLgResult=0 THEN exit;
  S:=' -ks '+p2+' -u '+PGP_USER_NAME;
  ClrScr;
   {$IFNDEF LINUX}
  SetMemTop(HeapPtr);
  SwapVectors;
  EXEC(GETENV('PGPPATH')+'PGP.EXE',S);
  SwapVectors;
  SetMemTop(HeapEnd);
   {$ENDIF}
  IF IORESULt<>0 THEN WRITE(#7);
  Redrawscreen;
END;

END.