UNIT QuickSet; {Mal wieder eine Q&D Unit, weil das eigentliche Projekt
               zu komplex wurde}
{$R-}

INTERFACE

 PROCEDURE ReadConfig;
 PROCEDURE WriteConfig;

IMPLEMENTATION

USES Toolbox,Iadvar,dos,
     input,
     {$IFDEF WA8DED}
     TNC,
     V24DRV,
     {$ENDIF}
     mystring,screen,crt,mcutlib,mcutlib2,startup,mcutbuf;

VAR f:text;
    line,error:word;
    a_long:longint;
    err:integer;
    zeile,path_to_exe:STRING[120];
    write_to_channel:BYTE;

PROCEDURE WriteError(s:string);
var s2,s3:STRING[40];
BEGIN
  str(line,s2);
  Write_to_Channel:=0;
  IF Write_To_Channel=0 THEN
    IF USE_CRT THEN
      WriteLn('Error line '+s2+':'+s)
    ELSE
     PopUp('Error line '+s2+':'+s)
  ELSE
    PutData(write_to_channel,'Error line '+s2+':'+s);
END;

FUNCTION whichitem(s:string):BYTE;
CONST
  item_anz=8;
  item_strings:ARRAY[1..item_anz] OF STRING[20]=
               ('color','video','packet','terminal','box',
                'directories','prio','pgp');
  b:BYTE=0;
BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings[b])))=item_strings[B] THEN
    BEGIN
      whichitem:=b;
      exit;
    END;

  whichitem:=0;
END;

FUNCTION checkerr:boolean;
BEGIN
  IF err>0 THEN
  BEGIN
    WriteError('numerical value expected.');
    inc(error);
    checkerr:=FALSE;
  END ELSE
    checkerr:=TRUE;
END;

PROCEDURE r_video(var s:string);

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=14;
    b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
    1:item_strings:='resolution';
    2:item_strings:='position_type';
    3:item_strings:='menu_position';
    4:item_strings:= 'status1_position';
    5:item_strings:='qso_position';
    6:item_strings:= 'status2_position';
    7:item_strings:= 'vorschreib_position';
    8:item_strings:= 'monitor_position';
    9:item_strings:= 'popup_duration';
    10:item_strings:= 'qsowinsize';
    11:item_strings:= 'moniwinsize';
    12:item_strings:= 'qsobufsizes';
    13:item_strings:= 'monibufsize';
    14:item_strings:= 'bigmoniwinsize';
 ELSE
    item_strings:='';
 END;
END;

BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIm(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;
VAR B:BYTE;l,r:STRING[80];

BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        IF NOT checkerr THEN exit;
        CASE a_long OF
          25:EGAVGAFont:=0;
          34:EGAVGAFont:=1;
          {43:EGAVGAFont:=2;}
          50:EGAVGAFont:=2;
	ELSE
	BEGIN
          WriteError('Possible values for resolution are 25,34,43,50. ');
          inc(error)
	END;  
        END;
      END;
    2:BEGIN
       IF NOT checkerr THEN exit;
       CASE a_long OF
         0 : Look_and_Feel:=0; {Userdefiniert}
         1 : BEGIN                 {BayCom}
             Look_and_Feel:=1;
             pMenue      := 1;
             pQSOWin     := 7;
             pVorschreib := 2;
             pStatus1    := 6;
             pStatus2    := 20;
             pMoni       := 21;
           END;
         2 : BEGIN                 {MCUT}
		Look_and_Feel:=2;
		pMenue      := 1;
		pQSOWin     := 3;
		pVorschreib := 17;
		pStatus1    := 2;
		pStatus2    := 16;
		pMoni       := 21;
	     END;
       ELSE
	  BEGIN
	     WriteError(' valid values for position_type are 0,1 and 2.');
	     inc(error);
	  END;
       END;
     END;
    3:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pMenu:=a_long;
      END;
    4:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pstatus1:=a_long;
      END;
    5:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pqsowin:=a_long;
      END;
    6:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pstatus2:=a_long;
      END;
    7:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pVorschreib:=a_long;
      END;
    8:BEGIN
        If Look_and_Feel>0 THEN exit;
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for positions must be between 1 and 50.');
          exit;
        END;
        pmoni:=a_long;
      END;
    9:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>15) or (a_long<1) THEN
        BEGIN
          WriteError('popup-duration must be between 1 and 15.');
          exit;
        END;
        PopUp_Duration:=a_long;
      END;
    10:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for sizes must be between 1 and 50.');
          exit;
        END;
        qsowinsize:=a_long;
      END;
    11:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>50) or (a_long<1) THEN
        BEGIN
          WriteError(' values for sizes must be between 1 and 50.');
          exit;
        END;
        moniwinsize:=a_long;
      END;
    12:BEGIN
         r:=zeile;
         b:=1;
         WHILE find(r,',',l,r) AND (b<250) DO
         BEGIN
           r:=ltrim(rtrim(r));
           val(l,bufsizes[b],err);
           IF (err>0) OR (bufsizes[b]<6) or (bufsizes[b]>59) THEN BEGIN
             WriteError('invalid value for "qsobufsizes":'+l);
             exit;
           END;
           inc(b);
         END;
         IF L<>'' THEN BEGIN
           val(l,bufsizes[b],err);
           IF (err>0) OR (bufsizes[b]<6) or (bufsizes[b]>59) THEN BEGIN
             WriteError('invalid value for "qsobufsizes":'+l);
             exit;
           END;
         END;
         bufsizes[0]:=bufsizes[1];
       END;
     13:BEGIN
          IF NOT CheckErr THEN exit;
          IF (a_long>59) OR (a_long<6) THEN
          BEGIN
            WriteError(' invalid value for "monibufsize"');
            exit;
          END;
          monibufsize:=a_long;
        END;
     14:BEGIN
          IF NOT CheckErr THEN exit;
          IF (a_long>59) OR (a_long<6) THEN
          BEGIN
            WriteError(' invalid value for "bigmoniwinsize"');
            exit;
          END;
          bigmoniwinsize:=a_long;
        END;



   END;
END;
PROCEDURE w_video(var f:text);
VAR b:BYTE;
BEGIN
  WriteLn(f,':Video');
  Write(f,'Resolution=');
  CASE EGAVGAFont OF
    0:WriteLn(f,'25');
    1:WriteLn(f,'34');
    {2:WriteLn(f,'43');}
    2:WriteLn(f,'50');
  END;
  WriteLn(f,'Position_Type=',Look_and_Feel);
  WriteLn(f,'Menu_Position=',pMenu);
  WriteLn(f,'Status1_Position=',pStatus1);
  WriteLn(f,'Qso_Position=',pQSOwin);
  WriteLn(f,'Status2_Position=',pStatus2);
  WriteLn(f,'Vorschreib_Position=',pVorschreib);
  WriteLn(f,'Monitor_Position=',pMoni);
  WriteLn(f,'PopUp_Duration=',PopUp_Duration);
  WriteLn(f,'qsowinsize=',qsowinsize);
  WriteLn(f,'moniwinsize=',moniwinsize);
  WriteLn(f,'bigmoniwinsize=',bigmoniwinsize);
   Write(f,'qsobufsizes=');
  FOR B:=1 TO MaxTerminal DO
    Write(f,bufsizes[b],',');
  WriteLn(f);
  WriteLn(f,'monibufsize=',monibufsize);
END;

PROCEDURE r_prio(var s:string);

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=4;
    b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
    1:item_strings:='send';
    2:item_strings:='poll';
    3:item_strings:='handle';
    4:item_strings:='screen';
 ELSE
    item_strings:='';
 END;
END;

BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIm(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;
VAR B:BYTE;l,r:STRING[10];

BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        IF NOT checkerr THEN exit;
        IF a_long<=20 THEN
          send_prio:=a_long
        ELSE
        BEGIN
          WriteError('Possible values are: 1-10. ');
          inc(error)
        END;
      END;
    2:BEGIN
        IF NOT checkerr THEN exit;
        IF a_long<=20 THEN
          poll_prio:=a_long
        ELSE
        BEGIN
          WriteError('Possible values are: 1-10. ');
          inc(error)
        END;
      END;
    3:BEGIN
        IF NOT checkerr THEN exit;
        IF a_long<=20 THEN
          handle_prio:=a_long
        ELSE
        BEGIN
          WriteError('Possible values are: 1-10. ');
          inc(error)
        END;
      END;
    4:BEGIN
        IF NOT checkerr THEN exit;
        IF a_long<=20 THEN
          screen_prio:=a_long
        ELSE
        BEGIN
          WriteError('Possible values are: 1-10. ');
          inc(error)
        END;
      END;
   END;
END;

PROCEDURE w_prio(var f:text);
VAR b:BYTE;
BEGIN
  WriteLn(f,':prio');
  WriteLn(f,'send=',send_prio);
  WriteLn(f,'poll=',poll_prio);
  WriteLn(f,'handle=',handle_prio);
  WriteLn(f,'screen=',screen_prio);
END;

PROCEDURE r_color(var s:string);
VAR vorder,hinter:BYTE;

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=16;
  b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
   1:item_strings:='menu_normal';
   2:item_strings:='statusline_one';
   3:item_strings:='statusline_two';
   4:item_strings:='rxdata';
   5:item_strings:='txdata';
   6:item_strings:='input_window';
   7:item_strings:='monitor_header';
   8:item_strings:='monitor_data';
   9:item_strings:='popup_window';
   10:item_strings:='dialog_background';
   11:item_strings:='dialog_active';
   12:item_strings:='dialog_inactive';
   13:item_strings:='dialog_button';
   14:item_strings:='dialog_title';
   15:item_strings:='menu_highlight';
   16:item_strings:='menu_selected';
  ELSE Item_strings:=''; END;
END;
  
BEGIN
  s:=LTRIM(s);
  FOR B:=1 to item_anz DO
  IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
  BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(copy(s,1,pos(',',s)-1),vorder,err);
      IF pos(',',s)>0 THEN
      BEGIN
        s:=copy(s,pos(',',s)+1,255);
        s:=LTRIM(s);
        val(s,hinter,err);
      END ELSE
      BEGIN
        whichitem:=255;
        WriteError('Invalid character in section "color"');
      END;
      IF err>0 THEN
      BEGIN
        whichitem:=255;
        WriteError('Invalid character in section "color"');
      END;
      exit;
    END;
  whichitem:=0;
END;

BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword');
        inc(error);
      END;
    1:fMenu:=vorder+hinter*16;
    2:fstatusoben:=vorder+hinter*16;
    3:fstatusunten:=vorder+hinter*16;
    4:fQsoRX:=vorder+hinter*16;
    5:fQsoTX:=vorder+hinter*16;
    6:fVorschreib:=vorder+hinter*16;
    7:fMonHead:=vorder+hinter*16;
    8:fMonData:=vorder+hinter*16;
    9:fPopUp:=vorder+hinter*16;
    10:fDlgbackground:=vorder+hinter*16;
    11:fDlgaktiv:=vorder+hinter*16;
    12:fDlgInAktiv:=vorder+hinter*16;
    13:fDlgButton:=vorder+hinter*16;
    14:fDlgtitel:=vorder+hinter*16;
    15:fMenuHigh:=vorder+hinter*16;
    16:fMenuMark:=vorder+hinter*16;
   END;
END;
PROCEDURE W_color(var f:text);

BEGIN
  WriteLn(f,':color');
  WriteLn(f,'Menu_Normal=',(fMenu MOD 16),',',(fMenu DIV 16));
  WriteLn(f,'Menu_Highlight=',(fMenuHigh MOD 16),',',(fMenuHigh DIV 16));
  WriteLn(f,'Menu_Selected=',(fMenuMark MOD 16),',',(fMenuMark DIV 16));
  WriteLn(f,'StatusLine_One=',(fStatusOben MOD 16),',',(fStatusOben DIV 16));
  WriteLn(f,'StatusLine_Two=',(fStatusUnten MOD 16),',',(fStatusUnten DIV 16));
  WriteLn(f,'RxData=',(fQSORx MOD 16),',',(fQSOrx DIV 16));
  WriteLn(f,'TxData=',(fQSOtx MOD 16),',',(fQSOtx DIV 16));
  WriteLn(f,'Input_Window=',(fVorschreib MOD 16),',',(fVorschreib DIV 16));
  WriteLn(f,'PopUp_Window=',(fpopup MOD 16),',',(fpopup DIV 16));
  WriteLn(f,'Monitor_Header=',(fMonHead MOD 16),',',(fMonHead DIV 16));
  WriteLn(f,'Monitor_Data=',(fMonData MOD 16),',',(fMonData DIV 16));
  WriteLn(f,'Dialog_BackGround=',(fDlgBackGround MOD 16),',',(fDlgBackGround DIV 16));
  WriteLn(f,'Dialog_Active=',(fDlgAktiv MOD 16),',',(fDlgAktiv DIV 16));
  WriteLn(f,'Dialog_InActive=',(fDlgInAKtiv MOD 16),',',(fDlgInAktiv DIV 16));
  WriteLn(f,'Dialog_Button=',(fDlgButton MOD 16),',',(fDlgButton DIV 16));
  WriteLn(f,'Dialog_Title=',(fDlgTitel MOD 16),',',(fDlgTitel DIV 16));

END;

PROCEDURE r_packet(var s:string);
FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=15;
    b:BYTE=0;

FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
   1  : item_strings:='comport';
   2  : item_strings:='interrupt';
   3  : item_strings:='port_adr';
   4  : item_strings:='terminal_baud';
   5  : item_strings:='tfchannels';
   6  : item_strings:='tf27flow_control';
   7  : item_strings:='ports';
   8  : item_strings:='paclen';
   9  : item_strings:='v24writedelay';
   10 : item_strings:='tncini';
   11 : item_strings:='tncdei';
   12 : item_strings:='budlist';
   13 : item_strings:='linklist';
   14 : item_strings:='device';
   15 : item_strings:='soft_tnc';
  ELSE item_strings:=''; END;
END;


BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;

BEGIN
  CASE whichitem(zeile) OF
    0  : BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=0) AND (a_long<=5) THEN
          _comport:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for comport are 1,2,3,4 OR 5 for TFPCX. ');
          inc(error)
        END;
      END;
    2  : BEGIN
        IF NOT checkerr THEN exit;
        IF _comport<5 THEN
        BEGIN
          IF (a_long>=0) AND (a_long<15) AND (_comport<5) THEN
            _interrupt:=a_long
          ELSE
          BEGIN
            WriteError('Valid values for interrupt are 1 to 15. ');
            inc(error)
          END;
        END ELSE
          IF (a_long>=$60) AND (a_long<$FF) OR (a_long=0) THEN
            _interrupt:=a_long
          ELSE
          BEGIN
            WriteError('Valid values for (TFPCX) interrupt are $60 to $FF. ');
            inc(error)
          END;
      END;
    3  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=0) AND (a_long<$500) THEN
          portaddress:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for adress are $001 to $500. ');
          inc(error)
        END;
      END;
    4  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=1200) AND (a_long<=115000) THEN
          baud:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for baudrate are (1200 baud) to (115000 baud). ');
          inc(error)
        END;
      END;
    5  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>3) AND (a_long<=250) THEN
          TNCchan:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for tfchannels are 4 to 250. ');
          inc(error)
        END;
      END;
    6  : BEGIN
        IF NOT checkerr THEN exit;
          flow_Control:=byte(a_long);
      END;
    7  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long<16) THEN
          ports:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for ports are 0 to 16. ');
          inc(error)
        END;
      END;
    8  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>39) AND (a_long<251) THEN
         paclen:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for paclen are 40 to 250 . ');
          inc(error)
        END;
      END;
    9  : BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=0) AND (a_long<50) THEN
         serwritedelay:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for v24writedelay are 0 to 50 . ');
          inc(error)
        END;
      END;
    10 : BEGIN
        PushQueue(TncIniCMDs,0,zeile);
       END;
    11 : BEGIN
        PushQueue(TncDeiCMDs,0,zeile);
       END;
    12 : BEGIN
         BudList:=Gross(Zeile);
         IF BudList[length(budlist)]<>' ' THEN
           BudList:=BudList+' ';
       END;
    13 : BEGIN
         LinkList:=Gross(Zeile);
         IF LinkList[length(LinkList)]<>' ' THEN
           LinkList:=LinkList+' ';
	 END;
    {$IFDEF linux}
    14 : BEGIN
	  tfkiss_path:=Zeile;
       END;
    15 : BEGIN
	    if not checkerr then exit;
	    tfkiss_flag := a_long;
	 END;

    {$ENDIF}
   END;

END;

PROCEDURE w_packet(var f:text);

VAR b:BYTE;p:pQueueRec;
BEGIN
  Writeln(f,':packet');
  WriteLn(f,'comport=',_comport);
  WriteLn(f,'interrupt=',_interrupt);
  WriteLn(f,'port_adr=',portaddress);
  WriteLn(f,'terminal_baud=',baud);
  WriteLn(f,'tfchannels=',TNCchan);
  WriteLn(f,'tf27flow_control=',flow_control);
  WriteLn(f,'ports=',ports);
  WriteLn(f,'paclen=',paclen);
  WriteLn(f,'v24writedelay=',serwritedelay);
  WriteLn(f,'budlist=',budlist);
  WriteLn(f,'linklist=',linklist);
  p:=TNCIniCmds;
  WHILE p<>NIL DO
  BEGIN
    WriteLn(f,'tncini=',p^.data);
    p:=p^.next;
  END;
  p:=TNCDeiCmds;
  WHILE p<>NIL DO
  BEGIN
    WriteLn(f,'tncdei=',p^.data);
    p:=p^.next;
  END;
{$IFDEF linux}
   WriteLn(f,'device=',tfkiss_path);
   WriteLn(f,'soft_tnc=',tfkiss_flag);
{$ENDIF}
END;

PROCEDURE r_terminal(var s:string);
VAR b1,b2:BYTE;

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=40;
    b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
   1 :item_strings:='max_terminal';
   2 :item_strings:='mycalls';
   3 :item_strings:='connect_sound';
   4 :item_strings:='disconnect_sound';
   5 :item_strings:='run_at_connect';
   6 :item_strings:='run_at_disconnect';
   7 :item_strings:='autorouting_prg';
   8 :item_strings:='ring_sound';
   9 :item_strings:='maxring';
   10:item_strings:='defaultlevel_in';
   11:item_strings:='defaultlevel_out';
   12:item_strings:='sysloglevel';
   13:item_strings:='log';
   14:item_strings:='-';
   15:item_strings:='keep:oncr';
   16:item_strings:='beepeol';
   17:item_strings:='keyboard';
   18:item_strings:='defumlaut';
   19:item_strings:='moni_decomp';
   20:item_strings:='main_call';
   21:item_strings:='default_remotes';
   22:item_strings:='default_flags';
   23:item_strings:='router_timeout';
   24:item_strings:='prompt';
   25:item_strings:='moni_tcpip';
   26:item_strings:='moni_bin';
   27:item_strings:='moni_chans';
   28:item_strings:='moni_typ';
   29:item_strings:='swap_types';
   30:item_strings:='moniswap_types';
   31:item_strings:='utcoffset';
   32:item_strings:='savebuf';
   33:item_strings:='crtsave';
   34:item_strings:='rxclick';
   35:item_strings:='moni_rpl_on';
   36:item_strings:='moni_rpl_max';
   37:item_strings:='ansi';
   38:item_strings:='echo';
   39:item_strings:='uproto_home';
   40:item_strings:='uproto_path';
  ELSE item_strings:='' END;
END;

BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;

VAR B:BYTE;l,r:STRING[10];
BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) AND (a_long<100) THEN
        BEGIN
          maxterminal:=byte(round(a_long));
        END
        ELSE
        BEGIN
          WriteError('Valid values for max_terminal are 1-100. ');
          inc(error)
        END;
      END;
    2:BEGIN
        zeile:=LTRIM(zeile);
        WHILE (zeile<>'') DO
        BEGIN
          find(zeile,' ',ein_s,zeile);
          zeile:=LTRIM(zeile);
          inc(mycallanz);
          (*smycall[mycallanz]:=gross(ein_s);*)
        END;
      END;
    3:BEGIN
        if zeile[length(zeile)]<>',' THEN
          Zeile:=Zeile+',';
        conbell:=zeile;
      END;
    4:BEGIN
        if zeile[length(zeile)]<>',' THEN
          Zeile:=Zeile+',';
        discbell:=Zeile;
      END;
    5:BEGIN
        run_at_connect:=zeile;
      END;
    6:BEGIN
        run_at_disconnect:=zeile;
      END;
    7:BEGIN
        (*
        autorouting_prg:=zeile;
        *)
      END;
    8:BEGIN
        if zeile[length(zeile)]<>',' THEN
          Zeile:=Zeile+',';
        ringbell:=zeile;
      END;
    9:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=0) AND (a_long<100) THEN
          maxring:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for maxring are 1-100. ');
          inc(error)
        END;
      END;
   18:BEGIN
        INC(UmlautTableAnz);
        New(UmlautTable[UmlautTableAnz]);
        new(UmlautDescription[UmlautTableAnz]);
        FOR B1:=0 to 255 DO UmlautTable[UmlautTableAnz]^[b1]:=char(b1);
        find(zeile,';',UmlautDescription[UmlautTableAnz]^,zeile);
        WHILE find(zeile,';',ein_s,zeile) DO
        BEGIN
          Val(copy(ein_s,1,Pos(':',ein_s)-1),b1,err);
          IF err>0 THEN exit;
          Val(copy(ein_s,Pos(':',ein_s)+1,255),b2,err);
          IF err>0 THEN exit;
          UmlautTable[UmlautTableAnz]^[b1]:=char(b2);
        END;
      END;
   19:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          monidecomp:=TRUE ELSE monidecomp:=FALSE;
      END;
   20:mycall:=gross(Zeile);
   21:BEGIN
        default_remotes:=a_long;
      END;
   22:BEGIN
        IF NOT checkerr THEN exit;
        default_flags:=a_long;
      END;
   23:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=1) AND (a_long<$FFFF) THEN
          router_timeout:=a_long
        ELSE
        BEGIN
          WriteError('Valid values for router_timeout are 1-65000. ');
          inc(error)
        END;

      END;
   24:BEGIN
         promptstr:=zeile;
      END;
   25:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          monitcpip:=TRUE ELSE monitcpip:=FALSE;
      END;
   26:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          monibin:=TRUE ELSE monibin:=FALSE;
      END;
   27:BEGIN
        IF NOT checkerr THEN exit;
        monitor_chans:=a_long;
      END;
   28:BEGIN
        IF NOT checkerr THEN exit;
        monitor_typ:=a_long;
      END;
   29:BEGIN
        IF NOT checkerr THEN exit;
        IF  (a_long<32) THEN
           BufSwapTypes:=a_long
        ELSE
        BEGIN
          WriteError('swap_types must be below 32. ');
          inc(error)
        END;
      END;
   30:BEGIN
        IF NOT checkerr THEN exit;
        IF  (a_long<32) THEN
           moniBufSwapTypes:=a_long
        ELSE
        BEGIN
          WriteError('moniswap_type must be below 32. ');
          inc(error)
        END;
      END;
   31:BEGIN
        IF NOT checkerr THEN exit;
        IF (ABS(a_Long)<=12) THEN
          utcoffset:=a_long
        ELSE
        BEGIN
          WriteError('utcoffset must be between -12 and 12.');
          inc(Error);
        END;
      END;
   32:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          SaveBuffers:=TRUE ELSE SaveBuffers:=FALSE;
      END;
   33:BEGIN
        IF NOT checkerr THEN exit;
        IF (ABS(a_Long)<=255) THEN
          crtsave:=a_long
        ELSE
        BEGIN
          WriteError('crtsave must be between 0 and 255.');
          inc(Error);
        END;
      END;
   34:BEGIN
        IF NOT checkerr THEN exit;
        IF (ABS(a_Long)<=3) THEN
          rxclick:=a_long
        ELSE
        BEGIN
          WriteError('rxclick must be between 0 and 3.');
          inc(Error);
        END;
      END;
   35:BEGIN
        IF NOT checkerr THEN exit;
        moni_rpl_an:=(a_long<>0);
      END;
   36:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>=0) THEN
          moni_rpl_file_size:=a_long
        ELSE
        BEGIN
          WriteError('moni_rpl_max is a filesize, has to be >= 0.');
          inc(Error);
        END;

      END;
   37:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          ansicolors:=TRUE ELSE ansicolors:=FALSE;
      END;
   38:BEGIN
        IF NOT checkerr THEN exit;
        IF (a_long>0) THEN
          termecho:=TRUE ELSE termecho:=FALSE;
      END;
   39:unproto_homebbs:=gross(zeile);
   40:unproto_path:=gross(zeile);

  END;
END;

PROCEDURE W_terminal(var f:text);

VAR b,b1,b2:BYTE;
BEGIN
  WriteLn(f,':Terminal');
  WriteLn(f,'max_terminal=',maxterminal);
  Write(f,'MyCalls=');
  (* FOR B:=1 to MyCallAnz DO
    WriteLn(f,smycall[b]+' '); *)
  WriteLn(f);
  WriteLn(f,'connect_sound=',conbell);
  WriteLn(f,'disconnect_sound=',discbell);
  WriteLn(f,'run_at_connect=',run_at_connect);
  WriteLn(f,'run_at_disconnect=',run_at_disconnect);
  (*
  WriteLn(f,'autorouting_prg=',autorouting_prg);
  *)
  WriteLn(f,'ring_sound=',ringbell);
  WriteLn(f,'maxring=',maxring);
  WriteLn(f,'SysLogLevel=',sysloglevel);
  WriteLn(f,'Log=',log);
  WriteLn(f,'keep:oncr=',holdcmdmode);
  WriteLn(f,'beepeol=',beepeol);
  WriteLn(f,'keyboard=',keyboard_type);
  Write(f,'moni_decomp=');
  IF monidecomp THEN
    WriteLn(f,'1') ELSE WriteLn(f,'0');
  FOR B:=1 TO UmlautTableAnz DO
  BEGIN
    Write(f,'defumlaut=',UmlautDescription[b]^,';');
    FOR B1:=0 to 255 DO
    IF UmlautTable[b]^[b1]<>char(b1) THEN
     Write(f,b1,':',byte(UmlautTable[b]^[b1]),';');
    WriteLn(f);
  END;
  WriteLn(f,'main_call=',mycall);
  WriteLn(f,'default_remotes=',default_remotes);
  WriteLn(f,'default_flags=',default_flags);
  WriteLn(f,'router_timeout=',router_timeout);
  WriteLn(f,'prompt=',promptstr);
  Write(f,'moni_tcpip=');
  IF monitcpip THEN
    WriteLn(f,'1') ELSE WriteLn(f,'0');
  Write(f,'moni_bin=');
  IF monibin THEN
    WriteLn(f,'1') ELSE WriteLn(f,'0');
  WriteLn(f,'moni_chans=',monitor_chans);
  WriteLn(f,'moni_typ=',monitor_typ);
  WriteLn(f,'swap_types=',BufSwapTypes);
  WriteLn(f,'moniswap_types=',MoniBufSwapTypes);
  WriteLn(f,'utcoffset=',utcoffset);
  Write(f,'savebuf=');
  IF Savebuffers THEN
    WriteLn(f,'1') ELSE WriteLn(f,'0');
  WriteLn(f,'crtsave=',crtsave);
  WriteLn(f,'rxclick=',rxclick);
  Write(f,'moni_rpl_on=');
  IF Moni_rpl_an THEN WriteLn(f,'1') ELSE
    WriteLn(F,'0');
  WriteLn(f,'moni_rpl_max=',moni_rpl_file_size);
  Write(f,'ansi=');
  IF ansicolors THEN WriteLn(f,'1') ELSE
    WriteLn(F,'0');
  Write(f,'echo=');  
  IF termecho THEN WriteLn(f,'1') ELSE
    WriteLn(f,'0');
END;


PROCEDURE r_directories(var s:string);
FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=8; b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
   1 :item_strings:='main_directory';
   2 :item_strings:='box_directory';
   3 :item_strings:='save_directory';
   4 :item_strings:='run_directory';
   5 :item_strings:='7plus_directory';
   6 :item_strings:='remote_directory';
   7 :item_strings:='text_directory';
   8 :item_strings:='temp_directory';
 ELSE item_strings:=''; END;
END;

BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;

var b1:byte;
BEGIN
  IF zeile[length(zeile)]<>PATH_SEP THEN zeile:=zeile+PATH_SEP;
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        qrvpath:=zeile;
      END;
    2:BEGIN
        boxpath:=zeile;
      END;
    3:BEGIN
        savpath:=zeile;
      END;
    4:BEGIN
        runpath:=zeile;
      END;
    5:BEGIN
        SevenPath:=zeile;
      END;
    6:BEGIN
        rempath:=zeile;
      END;
    7:BEGIN
        textpath:=zeile;
      END;
    8:BEGIN
        temppath:=zeile;
      END;
   END;
END;

PROCEDURE w_directories(var f:text);

BEGIN
  WriteLn(f,':directories');
  WriteLn(f,'main_directory=',qrvpath);
  WriteLn(f,'box_directory=',boxpath);
  WriteLn(f,'save_directory=',savpath);
  WriteLn(f,'run_directory=',runpath);
  WriteLn(f,'7plus_directory=',sevenpath);
  WriteLn(f,'remote_directory=',rempath);
  WriteLn(f,'text_directory=',textpath);
  WriteLn(f,'temp_directory=',temppath);
END;

PROCEDURE r_box(var s:string);

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=5;   b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
    1 :item_strings:='mycall';
    2 :item_strings:='convcall';
    3 :item_strings:='startbox';
    4 :item_strings:='startconv';
    5 :item_strings:='channels';
  ELSE item_strings:=''; END;
END;
  
BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;

BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        boxcall:=gross(zeile);
      END;
    2:BEGIN
        convcall:=gross(zeile);
      END;
    3:BEGIN
        if checkerr then exit;
        UseBox:=a_long;
      END;
    4:BEGIN
        if checkerr then exit;
        Useconv:=a_long;
      END;
    5:BEGIN
        if checkerr THEN exit;
        tfbbschans:=a_long;
      END;  
   END;
END;

PROCEDURE w_box(var f:text);
BEGIN
  WriteLn(f,':box');
  WriteLn(f,'startbox=',Usebox);
    WriteLn(f,'startconv=',Useconv);
  WriteLn(f,'mycall=',boxcall);
  WriteLn(f,'convcall=',convcall);
  WriteLn(f,'channels=',tfbbschans);
END;

PROCEDURE r_pgp(var s:string);

FUNCTION whichitem(var s:string):BYTE;
CONST
  item_anz=4;   b:BYTE=0;
FUNCTION item_strings(nr:BYTE):STRING20;
BEGIN
 CASE NR OF
    1 :item_strings:='userid';
    2 :item_strings:='sign';
    3 :item_strings:='checksig';
    4 :item_strings:='savepk';
  ELSE item_strings:=''; END;
END;
  
BEGIN
  s:=ltrim(s);
  FOR B:=1 to item_anz DO
    IF klein(copy(s,1,length(item_strings(b))))=item_strings(b) THEN
    BEGIN
      whichitem:=b;
      delete(s,1,length(item_strings(b)));
      s:=ltrim(s);
      if (s[1]<>'=') OR (s='') THEN
      BEGIN
        inc(error);
        WriteError(' "=" expected ');
        whichitem:=0;
        exit;
      END ELSE delete(s,1,1);
      s:=LTRIM(s);
      val(s,a_long,err);
      exit;
    END;
  whichitem:=0;
END;

BEGIN
  CASE whichitem(zeile) OF
    0:BEGIN
        WriteError('Invalid keyword.');
        inc(error);
      END;
    1:BEGIN
        PGP_USER_NAME:=gross(zeile);
      END;
    2:BEGIN
        IF NOT checkerr THEN exit;
        SIGN_MAIL:=(a_long<>0);
      END;
    3:BEGIN
        IF NOT checkerr THEN exit;
        CHECK_PGP_SIG:=(a_long<>0);
      END;
    4:BEGIN
        IF NOT checkerr THEN exit;
        SAVE_PUBLIC_KEYS:=(a_long<>0);

      END;

   END;
END;

PROCEDURE w_pgp(var f:text);
BEGIN
  WriteLn(f,':pgp');
  WriteLn(f,'userid=',PGP_USER_NAME);
  Write(f,'sign=');
  IF sign_mail THEN WriteLn(f,'1') ELSE WriteLn(f,'0');
  Write(f,'checksig=');
  IF check_pgp_sig THEN WriteLn(f,'1') ELSE WriteLn(f,'0');
  Write(f,'savepk=');
  IF save_public_keys THEN WriteLn(f,'1') ELSE WriteLn(f,'0');

END;

PROCEDURE MakeDir(Dir:STRING);
VAR S: STRING;
BEGIN
  S := COPY(Dir,1,3);
  Dir := COPY(Dir,4,255);
  REPEAT
    S := S + COPY(Dir,1,POS(PATH_SEP,Dir));
    Dir := COPY(Dir,POS(PATH_SEP,Dir)+1,255);
    {$I-}
    MKDIR(COPY(S,1,LENGTH(S)-1));
    {$I+}
    IF IOResult=0 THEN BEGIN END;
  UNTIL Dir = '';
END;
{$I-}
PROCEDURE AutoConf;
BEGIN
  {$IFDEF BOX}
  Makedir(boxpath);
  {$ENDIF}
  makedir(savpath);
  makedir(runpath);
  makedir(sevenpath);
  makedir(rempath);
  makedir(textpath);
  makedir(temppath);
  {$IFDEF HELP}
  makedir(helppath);
  {$ENDIF}
  default_remotes:=$FFFFFFF-RM1_ECHO;
  default_flags:=TU_REMOTE+TU_CONNECT+TU_RECONNECT;
  {$I-}
  assign(f,textpath+'ctext');
  reset(f);
  if ioresult=0 THEN
    close(f)
  ELSE
  BEGIN
    rewrite(f);
    if ioresult=0 THEN
    BEGIN
      WriteLn(f,'Welcome %n, to the MCUT-Terminal of %m!');
      close(f);
    END;
  END;
  assign(f,textpath+'qtext');
  reset(f);
  if ioresult=0 THEN
    close(f)
  ELSE
  BEGIN
    rewrite(f);
    if ioresult=0 THEN
    BEGIN
      WriteLn(f,'Bye %n, cuagn!');
      WriteLn(f,'73 es 55 de %m');
      close(f);
    END;
  END;
  assign(f,textpath+'info');
  reset(f);
  if ioresult=0 THEN
    close(f)
  ELSE
  BEGIN
    rewrite(f);
    if ioresult=0 THEN
    BEGIN
      WriteLn(f,'Information about PR-Station %m');
      WriteLn(f,'Computer: IBM compatible');
      WriteLn(f,'Software: MCUT %v by DG4IAD,DG6VJ,DG4MMI');
      WriteLn(f,'Uptime  : %2');
      close(f);
    END;
  END;
  installing:=2;
END;
{$I-}
PROCEDURE ReadConfig;

VAR current_item : BYTE;
sr		 : searchrec;
BEGIN
  current_item:=0;
  error:=0;
  PurgeQueue(TncIniCmds);
  PurgeQueue(TncDeiCmds);
{$IFDEF LINUX}
  IF GetEnv('MCUTCFG')<>'' THEN
   Assign(f,GetEnv('MCUTCFG'))
  ELSE
  BEGIN
    {IF (lo(dosversion)<3) or ((lo(dosversion)=3) and (hi(dosversion)<3)) THEN
    BEGIN
      WriteError('If using DOS 3.2 or lower, you have to set MCUTCFG to the MCUT.CFG file');
      WriteError('I doubt that MCUT will work on such old PC, but try it and tell me if it works (PLEASE!)');
      Halt(10);
    END;}
    path_to_exe:=getenv('HOME')+'/.mcut/';
   { FSplit(Paramstr(0),path_to_exe,zeile,zeile);}
    Assign(f,path_to_exe+'mcut.conf');
    qrvpath:=path_to_exe;
    boxpath:=qrvpath+'box/';
    savpath:=qrvpath+'save/';
    runpath:=qrvpath+'run/';
    sevenpath:=qrvpath+'7plus/';
    rempath:=qrvpath+'remote/';
    textpath:=qrvpath+'texte/';
    temppath:=qrvpath+'temp/';
    helppath:=qrvpath+'help/';
    xprogpath:=qrvpath+'xprg/';
  END;
  {$ELSE}
     IF GetEnv('MCUTCFG')<>'' THEN
   Assign(f,GetEnv('MCUTCFG'))
  ELSE
  BEGIN
    IF (lo(dosversion)<3) or ((lo(dosversion)=3) and (hi(dosversion)<3)) THEN
    BEGIN
      WriteError('If using DOS 3.2 or lower, you have to set MCUTCFG to the MCUT.CFG file');
      WriteError('I doubt that MCUT will work on such old PC, but try it and tell me if it works (PLEASE!)');
      Halt(10);
    END;
    FSplit(Paramstr(0),path_to_exe,zeile,zeile);
    Assign(f,path_to_exe+'MCUT.CFG');
    qrvpath:=path_to_exe;
    boxpath:=qrvpath+'BOX'+PATH_SEP;
    savpath:=qrvpath+'SAVE'+PATH_SEP;
    runpath:=qrvpath+'RUN'+PATH_SEP;
    sevenpath:=qrvpath+'7PLUS'+PATH_SEP;
    rempath:=qrvpath+'REMOTE'+PATH_SEP;
    textpath:=qrvpath+'TEXTE'+PATH_SEP;
    temppath:=qrvpath+'TEMP'+PATH_SEP;
    helppath:=qrvpath+'HELP'+PATH_SEP;
    xprogpath:=qrvpath+'XPRG'+PATH_SEP;
  END;
{$ENDIF}
{   findfirst(path_to_exe+'mcut.conf',anyfile,sr);
   if doserror<>0 THEN
   BEGIN
      AutoConf;
      exit;
   END;}
   {$I-}
  Reset(f);
  IF IORESULT<>0 THEN
  BEGIN
    AutoConf;
    exit;
  END;
   line:=0;
   WHILE not EOF(f) DO
   BEGIN
      ReadLn(f,zeile);
      INC(line);
      Zeile:=RTRIM(Zeile);
      Zeile:=LTRIM(Zeile);
    IF Zeile[1]<>'	;' THEN    {kommentar?}
    BEGIN
       IF Zeile[1]=':' THEN   {neuer abschnitt?}
       BEGIN
	  current_item:=whichitem(copy(zeile,2,255));
	  IF current_item=0 THEN
	  BEGIN
	     WriteError('Invalid paragraph specifier in MCUT.CFG: '+copy(zeile,1,20));
	     inc(error);
	  END ELSE
;
       END ELSE
       BEGIN
	  CASE current_item OF
	    1 : r_color(zeile);
	    2 : r_video(zeile);
	    3 : r_packet(zeile);
	    4 : r_terminal(zeile);
	    5 : r_box(zeile);
	    6 : r_directories(zeile);
	    7 : r_prio(zeile);
	    8 : r_pgp(zeile);
	  END;
       END;
    END;
  END;
  close(f);
  SetTZOffs(utcoffset);
END;




PROCEDURE WriteConfig;
VAR current_item:BYTE;
BEGIN
  current_item:=0;
  error:=0;
  IF GetEnv('MCUTCFG')<>'' THEN
   Assign(f,GetEnv('MCUTCFG'))
  ELSE
  BEGIN
     {$IFNDEF linux}
    IF (lo(dosversion)<3) or ((lo(dosversion)=3) and (hi(dosversion)<3)) THEN
    BEGIN
      WriteError('If using DOS 3.2 or lower, you have to set MCUTCFG to the MCUT.CFG file');
      WriteError('I doubt that MCUT will work on such old PC, but try it and tell me if it works (PLEASE!)');
      Halt(10);
    END;
     
    FSplit(Paramstr(0),path_to_exe,zeile,zeile);
     Assign(f,path_to_exe+'MCUT.CFG');
     {$ELSE}
     Assign(f,qrvpath+'mcut.conf');
     {$ENDIF}
  END;
  Rewrite(f);
  w_color(f);
  w_video(f);
  w_packet(f);
  w_terminal(f);
  w_box(f);
  w_directories(f);
  w_prio(f);
  w_pgp(f);
  close(f);
END;


END.





