(*************************************************************************)
(* FindErr-Utility fr MCUT                                              *)
(*                                                                       *)
(* Dieses Utility nimmt als Input die DEBUG.MCT und eine dazu passende   *)
(* MCUT.MAP und gibt die RTEs mit Filename und Zeilennummer aus.         *)
(* Beim Compilieren muss "Debug Information" "local symbols" und         *)
(* MAP-File, detailed aktiviert sein. Ich hoffe, da die BP7 .MAP        *)
(* das selbe Format haben.                                               *)
(* (iad, feb 95)                                                         *)
(*************************************************************************)

PROGRAM findErr;
USES MyString,toolbox;

TYPE Tadr=RECORD
       seg,offs,typ:WORD;
     END;

VAR db,map:TEXT;
    ERRORS:ARRAY[1..50] OF Tadr;
    ae,b,c:BYTE;
    aktadr:Tadr;
    aktmodul:STRING;
    S,L,R:STRING;
    err:integer;
    line:WORD;
BEGIN
   ae:=0;
   ASSIGN(db,paramstr(1));
   RESET(db);
   IF IORESULT<>0 THEN exit;
   aktmodul:='';
   WHILE NOT EOF(db) DO
   BEGIN
     ReadLN(db,s);
     IF COPY(S,1,3)='RE#' THEN
     BEGIN
       INC(ae);
       FIND(S,'#',L,R);
       FIND(R,'@',L,R);
       VAL(l,errors[ae].typ,err);
       FIND(R,':',L,R);
       VAL('$'+l,errors[ae].seg,err);
       FIND(R,'t',L,R);
       VAL('$'+l,errors[ae].offs,err);
     END;
   END;
   CLOSE(db);
   ASSIGN(map,paramstr(2));
   RESET(map);
   IF IOResult<>0 THEN exit;
   WHILE  NOT EOF(map) DO
   BEGIN
     ReadLN(map,s);
     IF FindStringStartPos(s,'ine numbers for')=2 THEN
     BEGIN
       S:=COPY(S,18,255);
       FIND(S,'(',l,r);
       aktmodul:=l;
     END ELSE
     IF (aktmodul<>'') AND (S[1]=' ') THEN
     BEGIN
       FOR B:=1 TO 4 DO
       BEGIN
         L:=copy(S,1,16);
         S:=copy(s,17,255);
         IF l<>'' THEN
         BEGIN
           L:=LTRIM(l);
           FIND(L,' ',L,R);
           VAL(l,line,err);
           FIND(R,':',L,R);
           VAL('$'+l,aktadr.seg,err);
           VAL('$'+r,aktadr.offs,err);
           FOR C:=1 TO ae DO
             IF (aktadr.seg=errors[c].seg) AND (aktadr.offs=errors[c].offs) THEN
                WriteLn('Runerror ',errors[c].typ,' in ',aktmodul,'.PAS, Zeile ',line,'.');
         END;
       END;
     END;
   END;
   close(Map);
END.